diff --git a/nxdrive/direct_transfer/tests/unit/test_handlers.py b/nxdrive/direct_transfer/tests/unit/test_handlers.py
new file mode 100644
index 000000000..23fd3ea35
--- /dev/null
+++ b/nxdrive/direct_transfer/tests/unit/test_handlers.py
@@ -0,0 +1,114 @@
+from datetime import date
+
+import pytest
+from nxdrive.direct_transfer import bootstrap
+from nxdrive.direct_transfer.adapters import repository
+from nxdrive.direct_transfer.domain import commands
+from nxdrive.direct_transfer.service_layer import handlers, unit_of_work
+
+
+class FakeRepository(repository.AbstractRepository):
+    def __init__(self, products):
+        super().__init__()
+        self._products = set(products)
+
+    def _add(self, product):
+        self._products.add(product)
+
+    def _get(self, sku):
+        return next((p for p in self._products if p.sku == sku), None)
+
+    def _get_by_batchref(self, batchref):
+        return next(
+            (p for p in self._products for b in p.batches if b.reference == batchref),
+            None,
+        )
+
+
+class FakeUnitOfWork(unit_of_work.AbstractUnitOfWork):
+    def __init__(self):
+        self.products = FakeRepository([])
+        self.committed = False
+
+    def _commit(self):
+        self.committed = True
+
+    def rollback(self):
+        pass
+
+
+def bootstrap_test_app():
+    return bootstrap.bootstrap(
+        start_orm=False,
+        uow=FakeUnitOfWork(),
+        notifications=lambda *args: None,
+        publish=lambda *args: None,
+    )
+
+
+class TestAddBatch:
+    def test_for_new_product(self):
+        bus = bootstrap_test_app()
+        bus.handle(commands.CreateBatch("b1", "CRUNCHY-ARMCHAIR", 100, None))
+        assert bus.uow.products.get("CRUNCHY-ARMCHAIR") is not None
+        assert bus.uow.committed
+
+    def test_for_existing_product(self):
+        bus = bootstrap_test_app()
+        bus.handle(commands.CreateBatch("b1", "GARISH-RUG", 100, None))
+        bus.handle(commands.CreateBatch("b2", "GARISH-RUG", 99, None))
+        assert "b2" in [b.reference for b in bus.uow.products.get("GARISH-RUG").batches]
+
+
+class TestAllocate:
+    def test_allocates(self):
+        bus = bootstrap_test_app()
+        bus.handle(commands.CreateBatch("batch1", "COMPLICATED-LAMP", 100, None))
+        bus.handle(commands.Allocate("o1", "COMPLICATED-LAMP", 10))
+        [batch] = bus.uow.products.get("COMPLICATED-LAMP").batches
+        assert batch.available_quantity == 90
+
+    def test_errors_for_invalid_sku(self):
+        bus = bootstrap_test_app()
+        bus.handle(commands.CreateBatch("b1", "AREALSKU", 100, None))
+
+        with pytest.raises(handlers.InvalidSku, match="Invalid sku NONEXISTENTSKU"):
+            bus.handle(commands.Allocate("o1", "NONEXISTENTSKU", 10))
+
+    def test_commits(self):
+        bus = bootstrap_test_app()
+        bus.handle(commands.CreateBatch("b1", "OMINOUS-MIRROR", 100, None))
+        bus.handle(commands.Allocate("o1", "OMINOUS-MIRROR", 10))
+        assert bus.uow.committed
+
+
+class TestChangeBatchQuantity:
+    def test_changes_available_quantity(self):
+        bus = bootstrap_test_app()
+        bus.handle(commands.CreateBatch("batch1", "ADORABLE-SETTEE", 100, None))
+        [batch] = bus.uow.products.get(sku="ADORABLE-SETTEE").batches
+        assert batch.available_quantity == 100
+
+        bus.handle(commands.ChangeBatchQuantity("batch1", 50))
+        assert batch.available_quantity == 50
+
+    def test_reallocates_if_necessary(self):
+        bus = bootstrap_test_app()
+        history = [
+            commands.CreateBatch("batch1", "INDIFFERENT-TABLE", 50, None),
+            commands.CreateBatch("batch2", "INDIFFERENT-TABLE", 50, date.today()),
+            commands.Allocate("order1", "INDIFFERENT-TABLE", 20),
+            commands.Allocate("order2", "INDIFFERENT-TABLE", 20),
+        ]
+        for msg in history:
+            bus.handle(msg)
+        [batch1, batch2] = bus.uow.products.get(sku="INDIFFERENT-TABLE").batches
+        assert batch1.available_quantity == 10
+        assert batch2.available_quantity == 50
+
+        bus.handle(commands.ChangeBatchQuantity("batch1", 25))
+
+        # order1 or order2 will be deallocated, so we'll have 25 - 20
+        assert batch1.available_quantity == 5
+        # and 20 will be reallocated to the next batch
+        assert batch2.available_quantity == 30
diff --git a/nxdrive/direct_transfer/tests/unit/test_transfer.py b/nxdrive/direct_transfer/tests/unit/test_transfer.py
new file mode 100644
index 000000000..76bb47a81
--- /dev/null
+++ b/nxdrive/direct_transfer/tests/unit/test_transfer.py
@@ -0,0 +1,37 @@
+from nxdrive.direct_transfer.domain.model import Transfer, TransferItem
+
+
+def test_transfer_add_items():
+    transfer = Transfer(42)
+    item1 = TransferItem(0, "/foo")
+    item2 = TransferItem(1, "/foo")
+    item1_dupe = TransferItem(0, "/foo")
+    transfer.add(item1)
+    transfer.add(item1_dupe)
+    transfer.add(item2)
+    assert transfer._items == {item1, item2}
+
+
+def test_transfer_remove_items():
+    transfer = Transfer(42)
+    item1 = TransferItem(0, "/foo")
+    item2 = TransferItem(1, "/foo")
+    transfer.add(item1)
+    transfer.add(item2)
+    transfer.remove(item1)
+    assert transfer._items == {item2}
+
+
+def test_transfer_with_same_priorities():
+    transfer1 = Transfer(0)
+    transfer2 = Transfer(1)
+    transfer3 = Transfer(2)
+    assert transfer1.priority == transfer2.priority == transfer3.priority
+    assert transfer1 < transfer2 < transfer3
+
+
+def test_transfer_with_different_priorities():
+    transfer1 = Transfer(0, priority=1)
+    transfer2 = Transfer(1, priority=2)
+    transfer3 = Transfer(2, priority=0)
+    assert transfer3 < transfer1 < transfer2
diff --git a/nxdrive/direct_transfer/tests/unit/test_transfer_item_action.py b/nxdrive/direct_transfer/tests/unit/test_transfer_item_action.py
new file mode 100644
index 000000000..666fa86cd
--- /dev/null
+++ b/nxdrive/direct_transfer/tests/unit/test_transfer_item_action.py
@@ -0,0 +1,29 @@
+from nxdrive.direct_transfer.domain.model import TransferItemAction
+from nxdrive.direct_transfer.transfer import add_uploads
+
+
+def test_add_uploads_one_file(tmp_path):
+    file = tmp_path / "file.txt"
+    file.touch()
+
+    expected = [TransferItemAction("UP", file, "/remote-path")]
+    got = list(add_uploads(file, "/remote-path"))
+    assert got == expected
+
+
+def test_add_uploads_recursive(tmp_path):
+    file = tmp_path / "file.txt"
+    file.touch()
+    subfolder = tmp_path / "subfolder"
+    subfolder.mkdir()
+    subfile = tmp_path / "subfolder" / "file.txt"
+    subfile.touch()
+
+    expected = [
+        TransferItemAction("UP", tmp_path, "/remote-path"),
+        TransferItemAction("UP", file, f"/remote-path/{tmp_path.name}"),
+        TransferItemAction("UP", subfolder, f"/remote-path/{tmp_path.name}"),
+        TransferItemAction("UP", subfile, f"/remote-path/{tmp_path.name}/subfolder"),
+    ]
+    got = list(add_uploads(tmp_path, "/remote-path"))
+    assert got == expected
diff --git a/nxdrive/direct_transfer/transfer.py b/nxdrive/direct_transfer/transfer.py
new file mode 100644
index 000000000..0b90c0d56
--- /dev/null
+++ b/nxdrive/direct_transfer/transfer.py
@@ -0,0 +1,20 @@
+from logging import getLogger
+from pathlib import Path
+from typing import Generator
+
+from ..utils import get_tree_list
+from .domain import model
+
+log = getLogger(__name__)
+
+
+def add_uploads(
+    local_path: Path, remote_path: str
+) -> Generator[model.TransferItemAction, None, None]:
+    """Recursively plan *local_paths* upload to the given *remote_path*."""
+    if local_path.is_file():
+        yield model.TransferItemAction("UP", local_path, remote_path)
+    elif local_path.is_dir():
+        tree = get_tree_list(local_path, remote_path)
+        for path, computed_remote_path in sorted(tree):
+            yield model.TransferItemAction("UP", path, computed_remote_path)
diff --git a/nxdrive/engine/dao/sqlite.py b/nxdrive/engine/dao/sqlite.py
index 5cd9da4f6..b8e171231 100644
--- a/nxdrive/engine/dao/sqlite.py
+++ b/nxdrive/engine/dao/sqlite.py
@@ -115,9 +115,6 @@
     ("unsynchronized", "moved"): "unsynchronized",
     ("unsynchronized", "synchronized"): "unsynchronized",
     ("unsynchronized", "deleted"): "remotely_deleted",
-    # Direct Transfer
-    ("direct", "unknown"): "direct_transfer",
-    ("direct", "deleted"): "direct_transfer_replace_blob",
 }
 
 
@@ -630,7 +627,7 @@ def __init__(self, db: Path) -> None:
         self.reinit_processors()
 
     def get_schema_version(self) -> int:
-        return 10
+        return 11
 
     def _migrate_state(self, cursor: Cursor) -> None:
         try:
@@ -656,6 +653,7 @@ def _migrate_db(self, cursor: Cursor, version: int) -> None:
                 "   AND folderish = 0"
             )
             self.store_int(SCHEMA_VERSION, 1)
+
         if version < 2:
             cursor.execute(
                 "CREATE TABLE if not exists ToRemoteScan ("
@@ -664,16 +662,20 @@ def _migrate_db(self, cursor: Cursor, version: int) -> None:
                 ")"
             )
             self.store_int(SCHEMA_VERSION, 2)
+
         if version < 3:
             self._migrate_state(cursor)
             self.store_int(SCHEMA_VERSION, 3)
+
         if version < 4:
             self._migrate_state(cursor)
             cursor.execute("UPDATE States SET creation_date = last_remote_updated")
             self.store_int(SCHEMA_VERSION, 4)
+
         if version < 5:
             self._create_transfer_tables(cursor)
             self.store_int(SCHEMA_VERSION, 5)
+
         if version < 6:
             # Add the *filesize* field to the Downloads table,
             # used to display download metrics in the systray menu.
@@ -686,6 +688,7 @@ def _migrate_db(self, cursor: Cursor, version: int) -> None:
                 # so we can bypass the error
                 pass
             self.store_int(SCHEMA_VERSION, 6)
+
         if version < 7:
             # Remove the no-more-used *idx* field of Uploads.
             # SQLite does not support column deletion, we need to recreate
@@ -710,8 +713,8 @@ def _migrate_db(self, cursor: Cursor, version: int) -> None:
 
             # Delete the table
             cursor.execute("DROP TABLE Uploads_backup;")
-
             self.store_int(SCHEMA_VERSION, 7)
+
         if version < 8:
             if WINDOWS:
                 # Update the tmpname column to add the long path prefix on Windows
@@ -770,6 +773,27 @@ def _migrate_db(self, cursor: Cursor, version: int) -> None:
 
             self.store_int(SCHEMA_VERSION, 10)
 
+        if version < 11:
+            # With NXDRIVE-2006, Direct Transfer entries were removed from the sync database.
+            # Here we just do the cleanup without managing the conversion using the new database as
+            # the new database is only known from the Direct Transfer manager (outside of the current
+            # code scope) and it would require too many actions for a beta feature (at the time).
+            log.warning(
+                "Removing all Direct Transfers for the database migration, sorry :/"
+            )
+
+            for state in cursor.execute(
+                "SELECT * FROM States WHERE local_state = 'direct'"
+            ):
+                # Remove the eventual upload associated to the Direct Transfer ...
+                cursor.execute(
+                    "DELETE FROM Uploads WHERE path = ?", (state.local_path,)
+                )
+                # ... And remove the Direct Transfer
+                cursor.execute("DELETE FROM States WHERE id = ?", (state.id,))
+
+            self.store_int(SCHEMA_VERSION, 11)
+
     def _create_table(self, cursor: Cursor, name: str, force: bool = False) -> None:
         if name == "States":
             self._create_state_table(cursor, force)
@@ -1226,21 +1250,6 @@ def update_local_modification_time(self, row: DocPair, info: FileInfo) -> None:
                 (info.last_modification_time, row.id),
             )
 
-    def update_pair_state(self, row: DocPair) -> None:
-        """Update local, remote and pair states of a given *doc_pair*.
-        States should already be defined in the *doc_pair* attributes,
-        the goal is only to save them in the database.
-        """
-        row.pair_state = self._get_pair_state(row)
-
-        with self.lock:
-            con = self._get_write_connection()
-            c = con.cursor()
-            c.execute(
-                "UPDATE States SET local_state = ?, remote_state = ?, pair_state = ? WHERE id = ?",
-                (row.local_state, row.remote_state, row.pair_state, row.id),
-            )
-
     def get_valid_duplicate_file(self, digest: str) -> Optional[DocPair]:
         """Find a file already synced with the same digest as the given *digest*."""
         c = self._get_read_connection().cursor()
diff --git a/nxdrive/engine/engine.py b/nxdrive/engine/engine.py
index 13320d04e..e1f4e8581 100644
--- a/nxdrive/engine/engine.py
+++ b/nxdrive/engine/engine.py
@@ -28,6 +28,7 @@
     DelAction,
     TransferStatus,
 )
+from ..direct_transfer import DirectTransferManager
 from ..exceptions import (
     EngineInitError,
     InvalidDriveException,
@@ -41,7 +42,6 @@
     current_thread_id,
     find_icon,
     find_suitable_tmp_dir,
-    get_tree_list,
     if_frozen,
     safe_filename,
     safe_long_path,
@@ -102,9 +102,8 @@ class Engine(QObject):
     online = pyqtSignal()
 
     # Direct Transfer
-    directTranferDuplicateError = pyqtSignal(Path, Document)
+    directTransferDuplicateError = pyqtSignal(Path, Document)
     directTranferError = pyqtSignal(Path)
-    directTranferStatus = pyqtSignal(Path, bool)
 
     type = "NXDRIVE"
     # Folder locker - LocalFolder processor can prevent
@@ -187,6 +186,19 @@ def __init__(
         # Pause in case of no more space on the device
         self.noSpaceLeftOnDevice.connect(self.suspend)
 
+        # Set the Direct Transfer database file
+        db = self.manager.home / "direct_transfer" / f"{self.uid}.db"
+        db.parent.mkdir(exist_ok=True)
+
+        # And create the Direct Transfer manager
+        self.dt_manager = DirectTransferManager(
+            str(db),
+            self.uid,
+            self.remote,
+            done_callback=self.manager.directTransferStats.emit,
+            dupe_callback=self.directTransferDuplicateError.emit,
+        )
+
     def __repr__(self) -> str:
         return (
             f"<{type(self).__name__} "
@@ -399,70 +411,32 @@ def delete_doc(self, path: Path, mode: DelAction = None) -> None:
                     f"{doc_pair.remote_parent_path}/{doc_pair.remote_ref}"
                 )
 
-    def direct_transfer(self, local_paths: Set[Path], remote_ref: str) -> None:
+    def direct_transfer(
+        self, local_paths: Set[Path], remote_path: str, start: bool = True
+    ) -> None:
         """Plan the Direct Transfer."""
-        # self.directTranferStatus.emit(local_path[0], True)
-
-        def plan(path: Path, remote_uid: str) -> None:
-            """Actions to do (refactored in a function to prevent duplicate code between files and folders)."""
-            # Save the remote folder's reference into the file/folder xattrs
-            try:
-                self.local.set_remote_id(path, remote_uid)
-            except PermissionError:
-                log.warning(
-                    f"Cannot set the remote ID on {path!r}, skipping the upload"
-                )
-                return
-
-            # Add the path into the database to plan the upload
-            info = self.local.get_info(path, check=False)
-            self.dao.insert_local_state(info, parent_path=None, local_state="direct")
-
         # Save the remote location for next times
-        self.dao.update_config("dt_last_remote_location", remote_ref)
+        self.dao.update_config("dt_last_remote_location", remote_path)
 
-        for local_path in sorted(local_paths):
-            if local_path.is_file():
-                plan(local_path, remote_ref)
-            else:
-                tree = sorted(get_tree_list(local_path, remote_ref))
-                for path, remote_path in tree:
-                    plan(path, remote_path)
+        if self.dt_manager.is_completed:
+            # Create a new transfers session
+            self.dt_manager.reset()
+
+        # Add paths recursively and start uploading!
+        if local_paths:
+            self.dt_manager.add_all(local_paths, remote_path)
+            if start:
+                self.dt_manager.start()
 
     def direct_transfer_cancel(self, file: Path) -> None:
         """Cancel the Direct Transfer of the given local *file*."""
-        log.info(f"Direct Transfer of {file!r}, user choice: cancel the upload")
-
-        doc_pair = self.dao.get_state_from_local(file)
-        if not doc_pair:
-            # Magic teleportation?
-            log.warning("The doc pair disappeared?! Direct Transfer cancelled.")
-            return
-
-        # Cancel the upload, clean-up the database and local file
-        self.dao.remove_state(doc_pair)
-        self.local.remove_remote_id(file)
-        self.local.remove_remote_id(file, name="remote")
+        if self.dt_manager:
+            self.dt_manager.cancel(file)
 
     def direct_transfer_replace_blob(self, file: Path, doc: Document) -> None:
         """Replace the document's blob on the server."""
-        log.info(
-            f"Direct Transfer of {file!r}, user choice: "
-            f"replace the document's attached file (UID is {doc.uid!r})"
-        )
-
-        doc_pair = self.dao.get_state_from_local(file)
-        if not doc_pair:
-            # Magic teleportation?
-            log.warning("The doc pair disappeared?! Direct Transfer cancelled.")
-            return
-
-        # Plan the replacement of the document's blob on the server
-        doc_pair.remote_state = "deleted"
-        self.dao.update_pair_state(doc_pair)
-
-        # Repush the pair to be traited later
-        self.queue_manager.push(doc_pair)
+        if self.dt_manager:
+            self.dt_manager.replace_blob(file, doc.uid)
 
     def rollback_delete(self, path: Path) -> None:
         """ Re-synchronize a document when a deletion is cancelled. """
@@ -554,6 +528,8 @@ def resume(self) -> None:
             else:
                 thread.start()
         self.resume_suspended_transfers()
+        if self.dt_manager:
+            self.dt_manager.start()
         self.syncResumed.emit()
 
     def resume_transfer(self, nature: str, uid: int) -> None:
@@ -601,6 +577,8 @@ def suspend(self) -> None:
         log.info(f"Engine {self.uid} is suspending")
         self._pause = True
         self.dao.suspend_transfers()
+        if self.dt_manager:
+            self.dt_manager.stop()
         self.queue_manager.suspend()
         for thread in self._threads:
             thread.worker.suspend()
diff --git a/nxdrive/engine/processor.py b/nxdrive/engine/processor.py
index 151cd7b3e..ae921ab9a 100644
--- a/nxdrive/engine/processor.py
+++ b/nxdrive/engine/processor.py
@@ -22,7 +22,6 @@
 
 from ..behavior import Behavior
 from ..client.local import FileInfo
-from ..client.uploader.direct_transfer import DirectTransferUploader
 from ..constants import (
     CONNECTION_ERROR,
     LONG_FILE_ERRORS,
@@ -33,7 +32,6 @@
     TransferStatus,
 )
 from ..exceptions import (
-    DirectTransferDuplicateFoundError,
     DownloadPaused,
     DuplicationDisabledError,
     NotFound,
@@ -44,7 +42,6 @@
     UploadPaused,
 )
 from ..objects import DocPair, RemoteFileInfo
-from ..options import Options
 from ..utils import is_generated_tmp_file, lock_path, safe_filename, unlock_path
 from .workers import EngineWorker
 
@@ -314,16 +311,11 @@ def _execute(self) -> None:
                 self._postpone_pair(doc_pair, "MAX_RETRY_ERROR")
             except HTTPError as exc:
                 if exc.status == 404:
-                    if doc_pair.local_state == "direct":
-                        # Happening while Direct Transfer'ring a document,
-                        # that means the parent folder is not yet created. Postpone.
-                        self._postpone_pair(doc_pair, "Parent not yet synced")
-                    else:
-                        # We saw it happened once a migration is done.
-                        # Nuxeo kept the document reference but it does
-                        # not exist physically anywhere.
-                        log.info(f"The document does not exist anymore: {doc_pair!r}")
-                        self.dao.remove_state(doc_pair)
+                    # We saw it happened once a migration is done.
+                    # Nuxeo kept the document reference but it does
+                    # not exist physically anywhere.
+                    log.info(f"The document does not exist anymore: {doc_pair!r}")
+                    self.dao.remove_state(doc_pair)
                 elif exc.status == 409:  # Conflict
                     # It could happen on multiple files drag'n drop
                     # starting with identical characters.
@@ -401,23 +393,9 @@ def _execute(self) -> None:
                     self._postpone_pair(doc_pair, "Trashing not possible")
                 else:
                     self._handle_pair_handler_exception(doc_pair, handler_name, exc)
-            except DirectTransferDuplicateFoundError as exc:
-                # Ask the user what to do when a possible duplicate can be created by a Direct Transfer call
-                log.info(str(exc))
-                self.engine.directTranferDuplicateError.emit(exc.file, exc.doc)
             except Exception as exc:
                 # Workaround to forward unhandled exceptions to sys.excepthook between all Qthreads
                 sys.excepthook(*sys.exc_info())
-
-                # Show a notification for Direct Transfer errors
-                if doc_pair.pair_state.startswith("direct_transfer"):
-                    file = (
-                        doc_pair.local_path
-                        if WINDOWS
-                        else Path(f"/{doc_pair.local_path}")
-                    )
-                    self.engine.directTranferError.emit(file)
-
                 self._handle_pair_handler_exception(doc_pair, handler_name, exc)
             finally:
                 if soft_lock:
@@ -484,60 +462,6 @@ def _handle_pair_handler_exception(
             log.exception("Unknown error")
             self.increase_error(doc_pair, f"SYNC_HANDLER_{handler_name}", exception=e)
 
-    def _synchronize_direct_transfer(
-        self, doc_pair: DocPair, replace_blob: bool = False
-    ) -> None:
-        """Direct Transfer of a local file."""
-        if WINDOWS:
-            file = doc_pair.local_path
-        else:
-            # The path retrieved from the database will have its starting slash trimmed, restore it
-            file = Path(f"/{doc_pair.local_path}")
-
-        if not file.exists():
-            self.engine.directTranferError.emit(file)
-            log.warning(
-                f"Cancelling Direct Transfer of {file!r} because it does not exist anymore"
-            )
-            self.dao.remove_state(doc_pair)
-            self.dao.remove_transfer("upload", file)
-            return
-
-        # The remote path is stored as the remote ref in xattrs of the file
-        parent_path = self.local.get_remote_id(file)
-        if not parent_path:
-            self.engine.directTranferError.emit(file)
-            log.warning(
-                f"Cancelling Direct Transfer of {file!r} because it has no remote path set"
-            )
-            self.dao.remove_state(doc_pair)
-            self.dao.remove_transfer("upload", file)
-            return
-
-        # Do the upload
-        self.remote.upload(
-            file,
-            parent_path=parent_path,
-            engine_uid=self.engine.uid,
-            uploader=DirectTransferUploader,
-            replace_blob=replace_blob,
-        )
-
-        # Clean-up
-        self.dao.remove_state(doc_pair)
-        self.local.remove_remote_id(file)
-        self.local.remove_remote_id(file, name="remote")
-
-        # Display a notification only for big files (to prevent notifications flood)
-        if not doc_pair.folderish and doc_pair.size >= Options.big_file * 1024 * 1024:
-            self.engine.directTranferStatus.emit(file, False)
-
-        self.engine.manager.directTransferStats.emit(doc_pair.folderish, doc_pair.size)
-
-    def _synchronize_direct_transfer_replace_blob(self, doc_pair: DocPair) -> None:
-        """Force the blob replacement of the remote document (choice done by the user)."""
-        self._synchronize_direct_transfer(doc_pair, replace_blob=True)
-
     def _synchronize_conflicted(self, doc_pair: DocPair) -> None:
         if doc_pair.local_state == "moved" and doc_pair.remote_state in (
             "moved",
diff --git a/nxdrive/engine/queue_manager.py b/nxdrive/engine/queue_manager.py
index 3ea1b8b51..dc29e30b9 100644
--- a/nxdrive/engine/queue_manager.py
+++ b/nxdrive/engine/queue_manager.py
@@ -208,13 +208,6 @@ def push(self, state: Union[DocPair, QueueItem]) -> None:
                     f"{self._remote_file_queue.qsize()}"
                 )
             self.newItem.emit(row_id)
-        elif state.pair_state.startswith("direct_transfer"):
-            self._local_file_queue.put(state)
-            log.debug(
-                "Pushed to _local_file_queue, now of size: "
-                f"{self._local_file_queue.qsize()}"
-            )
-            self.newItem.emit(row_id)
         else:
             # deleted and conflicted
             log.info(f"Not processable state: {state!r}")
diff --git a/nxdrive/exceptions.py b/nxdrive/exceptions.py
index bf18737ef..9058bcbf5 100644
--- a/nxdrive/exceptions.py
+++ b/nxdrive/exceptions.py
@@ -1,9 +1,6 @@
 # coding: utf-8
-from pathlib import Path
 from typing import TYPE_CHECKING, Any
 
-from nuxeo.models import Document
-
 if TYPE_CHECKING:
     from .engine.engine import Engine  # noqa
 
@@ -14,26 +11,6 @@ class DriveError(Exception):
     pass
 
 
-class DirectTransferDuplicateFoundError(ValueError):
-    """
-    Exception raised when a duplicate file already exists on the server
-    and trying to Direct Transfer a local file with the same name.
-    """
-
-    def __init__(self, file: Path, doc: Document) -> None:
-        self.file = file
-        self.doc = doc
-
-    def __repr__(self) -> str:
-        return (
-            f"Document with the name {self.file.name!r} already found on the server: {self.doc}."
-            f"Direct Transfer of {self.file!r} postponed after the user decided what to do."
-        )
-
-    def __str__(self) -> str:
-        return repr(self)
-
-
 class DocumentAlreadyLocked(DriveError):
     """ In Direct Edit, a document is locked by someone else. """
 
diff --git a/nxdrive/gui/application.py b/nxdrive/gui/application.py
index a875653ac..37e0c7a95 100644
--- a/nxdrive/gui/application.py
+++ b/nxdrive/gui/application.py
@@ -845,7 +845,7 @@ def auth() -> None:
 
     @pyqtSlot(object)
     def _connect_engine(self, engine: Engine) -> None:
-        engine.directTranferDuplicateError.connect(
+        engine.directTransferDuplicateError.connect(
             self._direct_transfer_duplicate_error
         )
         engine.syncStarted.connect(self.change_systray_icon)
diff --git a/nxdrive/logging_config.py b/nxdrive/logging_config.py
index d8c7c5885..549e61085 100644
--- a/nxdrive/logging_config.py
+++ b/nxdrive/logging_config.py
@@ -193,6 +193,9 @@ def configure(
     # NXDRIVE-1918: filter out botocore logging (too verbose)
     logging.getLogger("botocore").setLevel(logging.ERROR)
 
+    # NXDRIVE-2006: filter out peewee logging (too verbose)
+    logging.getLogger("peewee").setLevel(logging.ERROR)
+
 
 def get_handler(name: str) -> Optional[logging.Handler]:
     for handler in logging.getLogger().handlers:
diff --git a/nxdrive/manager.py b/nxdrive/manager.py
index a003c29ac..9142931e2 100644
--- a/nxdrive/manager.py
+++ b/nxdrive/manager.py
@@ -407,6 +407,7 @@ def stop(self, euid: str = None) -> None:
                 continue
             if engine.is_started():
                 engine.stop()
+            engine.dt_manager.shutdown()
         self.osi.cleanup()
         self.dispose_db()
         self.stopped.emit()
diff --git a/nxdrive/notification.py b/nxdrive/notification.py
index ba7fb9ebb..f67a1ff2f 100644
--- a/nxdrive/notification.py
+++ b/nxdrive/notification.py
@@ -435,21 +435,6 @@ def __init__(self, file: Path) -> None:
         )
 
 
-class DirectTransferStatus(Notification):
-    """Display a notification when a Direct Transfer is starting or finished."""
-
-    def __init__(self, file: Path, status: bool) -> None:
-        label = "DIRECT_TRANSFER_START" if status else "DIRECT_TRANSFER_END"
-        values = [file.name]
-        super().__init__(
-            label,
-            title="Direct Transfer",
-            description=Translator.get(label, values=values),
-            level=Notification.LEVEL_INFO,
-            flags=Notification.FLAG_VOLATILE | Notification.FLAG_BUBBLE,
-        )
-
-
 class ErrorOpenedFile(Notification):
     def __init__(self, path: str, is_folder: bool) -> None:
         values = [short_name(path), APP_NAME]
@@ -518,16 +503,11 @@ def _connect_engine(self, engine: "Engine") -> None:
         engine.errorOpenedFile.connect(self._errorOpenedFile)
         engine.longPathError.connect(self._longPathError)
         engine.directTranferError.connect(self._direct_transfer_error)
-        engine.directTranferStatus.connect(self._direct_transfer_status)
 
     def _direct_transfer_error(self, file: Path) -> None:
         """Display a notification when a Direct Transfer is in error."""
         self.send_notification(DirectTransferError(file))
 
-    def _direct_transfer_status(self, file: Path, status: bool) -> None:
-        """Display a notification when a Direct Transfer is starting or finished."""
-        self.send_notification(DirectTransferStatus(file, status))
-
     def _errorOpenedFile(self, doc: DocPair) -> None:
         self.send_notification(ErrorOpenedFile(str(doc.local_path), doc.folderish))
 
diff --git a/nxdrive/report.py b/nxdrive/report.py
index cd3a16fef..a023941f6 100644
--- a/nxdrive/report.py
+++ b/nxdrive/report.py
@@ -71,6 +71,28 @@ def copy_logs(self, myzip: ZipFile) -> None:
             except Exception:
                 log.exception(f"Impossible to copy the log {rel_path!r}")
 
+    def copy_direct_transfer_dbs(self, myzip: ZipFile) -> None:
+        """Copy all log Direct Transfer databases to the ZIP report."""
+
+        folder = self._manager.home / "direct_transfer"
+        if not folder.is_dir():
+            return
+
+        for path in folder.iterdir():
+            if not path.is_file():
+                continue
+            if path.suffix != ".db":
+                continue
+
+            comp = ZIP_DEFLATED
+            rel_path = path.relative_to(self._manager.home)
+            try:
+                myzip.write(str(path), str(rel_path), compress_type=comp)
+            except Exception:
+                log.exception(
+                    f"Impossible to copy the Direct Transfer database {rel_path!r}"
+                )
+
     @staticmethod
     def copy_db(myzip: ZipFile, dao: "EngineDAO") -> None:
         """
@@ -125,6 +147,9 @@ def generate(self) -> None:
             for engine in self._manager.engines.values():
                 self.copy_db(zip_, engine.dao)
 
+            # Direct Transfer databases
+            self.copy_direct_transfer_dbs(zip_)
+
             # Logs
             self.copy_logs(zip_)
 
